unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleDnD, StdCtrls, ActiveX, ExtCtrls, ComCtrls, MSGSnatchers;

type
  TForm1 = class(TForm)
    OleDropTarget1: TOleDropTarget;
    FileDropSource1: TFileDropSource;
    GroupBox1: TGroupBox;
    Image1: TImage;
    GroupBox2: TGroupBox;
    ListBoxFormats: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    GroupBox3: TGroupBox;
    PageControl1: TPageControl;
    TabSheetUnsupported: TTabSheet;
    TabSheetCFHDrop: TTabSheet;
    TabSheetCFText: TTabSheet;
    TabSheetCFBitmap: TTabSheet;
    Label7: TLabel;
    MemoCFText: TMemo;
    ScrollBox1: TScrollBox;
    ImageCFBitmap: TImage;
    MemoCFHDrop: TMemo;
    FileDropTarget1: TFileDropTarget;
    GroupBox4: TGroupBox;
    Label8: TLabel;
    MemoFileDrag: TMemo;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    procedure DFItem_CF_HDROP_Drop(aSender: TObject;
      var aContext: TDragContext);
    procedure DFItem_CF_TEXT_Drop(aSender: TObject;
      var aContext: TDragContext);
    procedure DFItem_CF_BITMAP_Drop(aSender: TObject;
      var aContext: TDragContext);
    procedure FileDropTarget1DragEnter(aSender: TObject;
      var aContext: TDragContext);
    procedure FileDropTarget1DragOver(aSender: TObject;
      var aContext: TDragContext);
    procedure FileDropTarget1DragLeave(aSender: TObject;
      var aResult: HRESULT);
    procedure FileDropTarget1Drop(aSender: TObject;
      var aContext: TDragContext);
    procedure OleDropTarget1DragEnter(aSender: TObject;
      var aContext: TDragContext);
  private
    { Private 錾 }
    procedure AddFormatEtc(const aFormat: TFormatEtc);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  OleDnDUtils, DataObjects;

{$R *.dfm}

procedure TForm1.AddFormatEtc(const aFormat: TFormatEtc);
begin
  ListBoxFormats.Items.Add(GetCFName(aFormat.cfFormat));
end;

procedure TForm1.OleDropTarget1DragEnter(aSender: TObject;
  var aContext: TDragContext);
var
  reader: TDataObjectReader;
begin
  ListBoxFormats.Clear;
  reader := TDataObjectReader.Create(aContext.DataObject);
  try
    reader.GetFormats(AddFormatEtc);
  finally
    reader.Free;
  end;
end;

procedure TForm1.DFItem_CF_HDROP_Drop(aSender: TObject;
  var aContext: TDragContext);
var
  reader: TDataObjectReader;
begin
  PageControl1.ActivePage := TabSheetUnsupported;
  MemoCFHDrop.Clear;
  reader := TDataObjectReader.Create(aContext.DataObject);
  try
    reader.GetAsFileList(MemoCFHDrop.Lines);
    PageControl1.ActivePage := TabSheetCFHDrop;
  finally
    reader.Free;
  end;
end;

procedure TForm1.DFItem_CF_TEXT_Drop(aSender: TObject;
  var aContext: TDragContext);
var
  reader: TDataObjectReader;
begin
  PageControl1.ActivePage := TabSheetUnsupported;
  MemoCFText.Clear;
  reader := TDataObjectReader.Create(aContext.DataObject);
  try
    MemoCFText.Text := reader.AsText;
    PageControl1.ActivePage := TabSheetCFText;
  finally
    reader.Free;
  end;
end;

procedure TForm1.DFItem_CF_BITMAP_Drop(aSender: TObject;
  var aContext: TDragContext);
var
  reader: TDataObjectReader;
  bitmap: Graphics.TBitmap;
begin
  PageControl1.ActivePage := TabSheetCFBitmap;
  MemoCFHDrop.Clear;
  reader := TDataObjectReader.Create(aContext.DataObject);
  bitmap := Graphics.TBitmap.Create;
  try
    if reader.HasFormat(CF_PALETTE) then
      bitmap.Palette := reader.GetAsHandle(CF_PALETTE);
    reader.GetAsBitmap(bitmap);
    ImageCFBitmap.Picture.Bitmap := bitmap;
    PageControl1.ActivePage := TabSheetCFBitmap;
  finally
    bitmap.Free;
    reader.Free;
  end;
end;

procedure TForm1.FileDropTarget1DragEnter(aSender: TObject;
  var aContext: TDragContext);
begin
  MemoFileDrag.Clear;
  MemoFileDrag.Lines.Add('DragEnter');
end;

procedure TForm1.FileDropTarget1DragOver(aSender: TObject;
  var aContext: TDragContext);
begin
  MemoFileDrag.Lines.Add('DragOver');
end;

procedure TForm1.FileDropTarget1DragLeave(aSender: TObject;
  var aResult: HRESULT);
begin
  MemoFileDrag.Lines.Add('DragLeave');
end;

procedure TForm1.FileDropTarget1Drop(aSender: TObject;
  var aContext: TDragContext);
begin
  MemoFileDrag.Lines.Add('Drop');
  MemoFileDrag.Lines.Add(FileDropTarget1.DroppedFiles.Text);
end;

end.

